#version 330


in vec2 vTexcoord;
uniform sampler2D blurTexture;
uniform sampler2D uTexLinearDepth;

uniform float nearPlane;
uniform float farPlane;


uniform mat4 uInverseViewProj;		//inverse view->projection
uniform mat4 uPrevViewProj; // previous view->projection
uniform int nSamples;
uniform float mblurScale;

layout(location = 0) out vec4 result;

void main(){


	// Get the depth buffer value at this pixel.  
   float zOverW = texture2D(uTexLinearDepth, vTexcoord).r;
     
// H is the viewport position at this pixel in the range -1 to 1.  
  // vec4 H = vec4(vTexcoord.x * 2 - 1, (1 - vTexcoord.y) * 2 - 1,  zOverW, 1); 
   vec4 H = vec4(vTexcoord.x * 2 - 1, vTexcoord.y * 2 - 1,  zOverW, 1); 
    
// Transform by the view-projection inverse.  
   vec4 D = uInverseViewProj * H; 
    
// Divide by w to get the world position.  
   vec4 worldPos = D / D.w;  

     // Current viewport position  
   vec4 currentPos = H;  

// Use the world position, and transform by the previous view-projection matrix.  
   vec4 previousPos = uPrevViewProj* worldPos;  

// Convert to nonhomogeneous points [-1,1] by dividing by w.  
previousPos /= previousPos.w;  

// Use this frame's position and last frame's to compute the pixel velocity.  
   vec2 velocity = (currentPos - previousPos).xy; 


   float mblurStaerke = 10;
   

   //Framerate-unabhngiger Blur durch mblurScale
  // velocity *= mblurScale;

	velocity /= mblurStaerke;
   vec2 blurVec = velocity;

 
      // perform blur:
		result = texture2D(blurTexture, vTexcoord);
       for (int i = 1; i < nSamples; ++i) {
       // get offset in range [-0.5, 0.5]:
      vec2 offset = blurVec * (float(i) / float(nSamples - 1) - 0.5);
  
     // sample & add to result:
      result += texture2D(blurTexture, vTexcoord + offset);
    }
 
    result /= float(nSamples);
	
}